(function($) {

	//メッセージアニメプラグイン
	TYRANO.kag.tmp._is_msg_anime = false;

	(function(){
		TYRANO.kag.ftag.master_tag.msg_anime_in = object({
			pm: {
				layer : "",
				name: "",
				fix: "false",
				time: "500",
				effect: "fadeIn",
				wait: "true",
				skip: "true"
			},
			start : function(pm) {

				var that = this;
				var layer = "";
				var message = "";

				if (pm.layer == "") {
					layer = "." + this.kag.stat.current_layer + "_fore";
				} else {
					layer = "." + pm.layer + "_fore";
				}
				message = layer;
				
				if (pm.name != "") {
					layer += ", ." + pm.name.replace(",",", .")
				}

				if (pm.fix == "true") {
					layer += ", .fixlayer";
				}
				
				var m_time = parseInt(pm.time);
				var wait = pm.wait;


				if ( pm.skip == "true" && this.kag.stat.is_skip == true ) {
					m_time = 10;
					wait = "true";
				}

				this.kag.tmp._is_msg_anime = true;
				
				$.when(
					$(layer)
					.css({"animation-duration": m_time + "ms", "animation-fill-mode": "both"})
					.addClass(pm.effect)
					.fadeIn(m_time, function() {
						$(this)
						.css({"animation-duration": "", "animation-fill-mode": ""})
						.removeClass(pm.effect)
					})
				).done(function(){ 
					$(message).attr("l_visible", "true");
					that.kag.tmp._is_msg_anime = false;
					if ( wait != "false" ) {
						that.kag.ftag.nextOrder();
					}
				});

				if ( wait == "false" ) {
					that.kag.ftag.nextOrder();
				}
			}
		});
		TYRANO.kag.ftag.master_tag.msg_anime_in.kag = TYRANO.kag;
	})();

	(function(){
		TYRANO.kag.ftag.master_tag.msg_anime_out = object({
			pm: {
				layer : "",
				name: "",
				fix: "false",
				time: "500",
				effect: "fadeOut",
				wait: "true",
				skip: "true"
			},
			start : function(pm) {

				var that = this;
				var layer = "";
				var message = "";

				if (pm.layer == "") {
					layer = "." + this.kag.stat.current_layer + "_fore";
				} else {
					layer = "." + pm.layer + "_fore";
				}
				message = layer;
				
				if (pm.name != "") {
					layer += ", ." + pm.name.replace(",",", .")
				}

				if (pm.fix == "true") {
					layer += ", .fixlayer";
				}
				
				var m_time = parseInt(pm.time);
				var wait = pm.wait;


				if ( pm.skip == "true" && this.kag.stat.is_skip == true ) {
					m_time = 10;
					wait = "true";
				}

				this.kag.tmp._is_msg_anime = true;

				$.when(
					$(layer)
					.css({"animation-duration": m_time + "ms", "animation-fill-mode": "both"})
					.addClass(pm.effect)
					.fadeOut(m_time, function() {
						$(this)
						.css({"animation-duration": "", "animation-fill-mode": ""})
						.removeClass(pm.effect)
					})
				).done(function(){ 
					$(message).attr("l_visible", "false");
					that.kag.tmp._is_msg_anime = false;
					if ( wait != "false" ) {
						that.kag.ftag.nextOrder();
					}
				});

				if ( wait == "false" ) {
					that.kag.ftag.nextOrder();
				}

			}
		});
		TYRANO.kag.ftag.master_tag.msg_anime_out.kag = TYRANO.kag;
	})();

	(function(){
		let _hideMessage = tyrano.plugin.kag.key_mouse.hidemessage;
		tyrano.plugin.kag.key_mouse.hidemessage = function(){
			if(this.kag.tmp._is_msg_anime){
				return;
			}

			_hideMessage.call(this);
		};
	})();

})(jQuery);
